﻿using System.Collections;
using System.Collections.Generic;
using TreeEditor;
using UnityEngine;
using UnityEngine.Assertions.Must;


//Clase encargada del movimiento de la camara
public class MovCamara : MonoBehaviour
{
    protected Transform cameraView;
    protected Transform reference;

    protected Vector3 rotationReference;
    protected Vector3 moveReference;
    protected float cameraDistance = 1000f;

    //Establece la sensibilidad del movimeineto de la camara
    public float mouseSen = 4f;
    public float scrollSen = 2f;
    public float orbitDamp = 10f;
    public float scrollDamp = 6f;

    public bool cameraDisable = false;

    void Start()
    {
        cameraView = transform;
        reference = transform.parent;
    }

    void LateUpdate()
    {
        //Desactivar/activar el movimiento de la camara
        if (Input.GetKeyDown(KeyCode.LeftShift))
        {
            cameraDisable = !cameraDisable;
        }
       
        if (!cameraDisable)
        {
            moveReference = reference.position;
            //Mueve referencia/posicion de la camara
            if (Input.GetMouseButton(2))
            {
                moveReference.x += Input.GetAxis("Mouse X") * mouseSen * 100;
                moveReference.z += Input.GetAxis("Mouse Y") * mouseSen * 100;
                moveReference.y = 0;
                reference.position = moveReference;
            }
            //Rotacion de la camara
            if ((Input.GetAxis("Mouse X") != 0 || Input.GetAxis("Mouse Y") != 0) && Input.GetMouseButton(1))
            {
                rotationReference.x += Input.GetAxis("Mouse X") * mouseSen;
                rotationReference.y -= Input.GetAxis("Mouse Y") * mouseSen;
                rotationReference.y = Mathf.Clamp(rotationReference.y, -90f, 90f);
            }
            //Acercar/alejar camara
            if (Input.GetAxis("Mouse ScrollWheel") != 0)
            {
                float scrollAmount = Input.GetAxis("Mouse ScrollWheel") * scrollSen;
                scrollAmount *= (cameraDistance * 0.3f);
                cameraDistance += scrollAmount;
                cameraDistance = Mathf.Clamp(cameraDistance, 1.5f, 100000f);
            }
        }

        //Transformacion a cuaterniones
        Quaternion qt = Quaternion.Euler(0, rotationReference.x, rotationReference.y);
        reference.rotation = Quaternion.Lerp(reference.rotation, qt, Time.deltaTime * orbitDamp);

        if (cameraView.localPosition.x != cameraDistance)
        {
            cameraView.localPosition = new Vector3(Mathf.Lerp(cameraView.localPosition.x, cameraDistance*-1f, Time.deltaTime * scrollDamp), 500f, 0f);
        }

    }






}
