﻿using System;
using System.IO;
using UnityEngine;

//Clase que se encarga de la gestion del archivo 
//que almacena las cordenadas de los puntos
public static class pointCloudFile
{
    private static FileStream fileStream;
    private static string fileName;
    private static StreamWriter writeToFile;
    private static bool wasCreated;

    public static void inicialize()
    {
        try
        {
            fileName = "pointCloud_" + DateTime.Now.ToString("yyyyMMdd_HHmmss") + ".txt";
            fileStream = fileStream = File.Create(fileName);
            writeToFile = new StreamWriter(fileStream);
            writeToFile.WriteLine("#/Date/calculated-X/calculated-Y/calculated-Z");
            wasCreated = true;
        }
        catch ( Exception e)
        {
            Debug.Log("pointCloud file ERROR: " + e.Message);
            wasCreated = false;
        }
        
    }

    public static bool exists()
    {
        return wasCreated;
    }

    public static bool saveData(int id, LidarPoint point, DateTime measuteDateTime)
    {
        try
        {
            string printTxt;
            printTxt = id + "/" + measuteDateTime.ToString("yyyyMMdd_HHmmss.fffffff") + "/";
            printTxt = printTxt + point.XYZposition.x + "/" + point.XYZposition.y + "/" + point.XYZposition.z;
            writeToFile.WriteLine(printTxt);
            return true;
        }
        catch
        {
            return false;
        }

    }

    public static void dispose()
    {
        writeToFile.Dispose();
        fileStream.Dispose();
    }


}
