#include "SPIcommunication.h"

//Funcion que envia los datos al Xbee via SPI
void SPIcommunication(byte *payload)
{
  unsigned int chksum=0;
  SPI.beginTransaction(SPISettings(1000000, MSBFIRST, SPI_MODE0));
  digitalWrite(SPI_SS,LOW);

  //Envio de la cabecera
  for(uint8_t i=0; i<TX_FRAME_HEADER_BYTES; i++)
  {
    SPI.transfer(TX_FRAME_HEADER[i]);
    if(i>2)
    {
      chksum = chksum + TX_FRAME_HEADER[i];
    }
  }
  //Envio de la carga util
  for(uint8_t i=0; i<TX_FRAME_PAYLOAD_BYTES; i++)
  {
    SPI.transfer(payload[i]);
    chksum = chksum + payload[i];
  }

  chksum = 0xFF - (0xFF & chksum);
  SPI.transfer(byte(chksum));

  digitalWrite(SS,HIGH);
  SPI.endTransaction();
}


//Funcion que recibe los datos provenientes del Xbee via SPI
void SPIcommunication(UnityCommand_t *unityCommand)
{
  unsigned int chksum=0;
  byte spiBuffer[RX_FRAME_TOTAL_BYTES];

  SPI.beginTransaction(SPISettings(1000000, MSBFIRST, SPI_MODE0));
  digitalWrite(SPI_SS,LOW);

  spiBuffer[0] = SPI.transfer(0);
  //Verificacion de inicio de trama
  while (spiBuffer[0] != 0x7E)
  {
    spiBuffer[0] = SPI.transfer(0);
  }
  //Recepcion de la trama
  for(uint8_t i=1; i<RX_FRAME_TOTAL_BYTES; i++)
  {
    spiBuffer[i] = SPI.transfer(0);
    if(i>2 && i<RX_FRAME_TOTAL_BYTES-1)
    {
      chksum = chksum + spiBuffer[i];
    }
  }
  digitalWrite(SS,HIGH);
  SPI.endTransaction();

  chksum = 0xFF - (0xFF & chksum);
  if(chksum == spiBuffer[RX_FRAME_TOTAL_BYTES-1])
  {
    //Comando en bytes en posiciones RX_FRAME_TOTAL_BYTES-2,-3,-4
    unityCommand->command = (char)spiBuffer[RX_FRAME_TOTAL_BYTES-4];
    unityCommand->value = (unsigned int) ((spiBuffer[RX_FRAME_TOTAL_BYTES-3] << 8) + spiBuffer[RX_FRAME_TOTAL_BYTES-2]);
  }
  else
  {
    unityCommand->command = 'X';
    unityCommand->value = 0;
  }
}
