#include <SPI.h>

//Definicion de pines arduino
#define SPI_ATTN                              9
#define SPI_SS                                10

//Caracteristicas trama de envio
#define MEASURES_PER_FRAME                    14
#define MEASURE_BYTES_SIZE                    6 //medidas de 6 bytes cada una
#define TX_FRAME_HEADER_BYTES                 17
#define TX_FRAME_PAYLOAD_BYTES                ( MEASURES_PER_FRAME * MEASURE_BYTES_SIZE)
#define TX_FRAME_TOTAL_BYTES                  ( TX_FRAME_HEADER_BYTES + TX_FRAME_PAYLOAD_BYTES + 1) //

//Caracteristicas trama de recepcion
#define COMMANDS_PER_FRAME                    1
#define COMMAND_BYTES_SIZE                    3 //comandos de 3 bytes cada uno
#define RX_FRAME_HEADER_BYTES                 15
#define RX_FRAME_PAYLOAD_BYTES                ( COMMANDS_PER_FRAME * COMMAND_BYTES_SIZE )
#define RX_FRAME_TOTAL_BYTES                  ( RX_FRAME_HEADER_BYTES  + RX_FRAME_PAYLOAD_BYTES + 1)

//Almace los comandos de Unity
typedef struct UnityCommand_t
{
  char command;
  unsigned int value;
}UnityCommand_t;

//Cabecera de la trama APi
const byte TX_FRAME_HEADER [] = {0x7E,0x00,(byte)(TX_FRAME_PAYLOAD_BYTES+14),0x10,0x00,0x00,0x13,0xA2,0x00,0x41,0xBB,0xC3,0x3D,0xFF,0xFE,0x00,0x00};

//Funcion que envia los datos al Xbee via SPI
void SPIcommunication(byte *payload);
//Funcion que recibe los datos provenientes del Xbee via SPI
void SPIcommunication(UnityCommand_t *unityCommand);
