#include "lidarMeasure.h"

//Funcion que almacena las medidas del lidar en la estructura
bool lidarMeasure(RPLidar *lidar, Measure_t *measure, bool startMapping)
{
  if (startMapping && IS_OK(lidar->waitPoint()))
  {
    measure->lidarDistance = (unsigned int) lidar->getCurrentPoint().distance; //distancia valor en mm
    measure->lidarAngle    = lidar->getCurrentPoint().angle; //angulo valor en grados
    return true;
  }
  else
  {
    //Detiene el motor del lidar
    analogWrite(RPLIDAR_MOTOR_CTL, 0); 

    //Obtiene la info del lidar para comprobar su funcinamiento
    rplidar_response_device_info_t info;
    if (startMapping && IS_OK(lidar->getDeviceInfo(info, 100)))
    {
      
       lidar->startScan();
       //Inicia el motor del lidar a la maxima velocidad
       analogWrite(RPLIDAR_MOTOR_CTL, 255);
    }
    return false;
  }
}
