#include "motorControl.h"

unsigned int steps = 0;

/*Control de movimiento del vehiculo
 *@param command direccion del moviminto
 *@param value valor de movimiento en cm
 */
bool motorsControl(char command, unsigned int value)
{
  steps = value/1.075;
  if(command == 'F')
  {
    forward();
    countSteps(steps);
    stop();
  }

  if(command == 'B')
  {
    backward();
    countSteps(steps);
    stop();
  }

  if(command == 'L')
  {
    left();
    countSteps(steps/3);
    stop();
  }

  if(command == 'R')
  {
    right();
    countSteps(steps/3);
    stop();
  }
  return false;
}

/*Cuenta los pasos del encoder
 * @param steps pasos a contar
*/
void countSteps(unsigned int steps)
{
  bool step = true;
  unsigned int count = 0;
  while(count <= steps)
  {
    if(digitalRead(ENCODER) == ENCODER_ON && !step)
    {
      step = true;
      count++;
      delay(10);
    }
    if(digitalRead(ENCODER) == ENCODER_OFF )
    {
      step = false;
    }

  }
}

void forward()
{
  digitalWrite(LEFT_MOTOR_DIRECTION, GOING_FORWARD);
  digitalWrite(RIGHT_MOTOR_DIRECTION, GOING_FORWARD);
  analogWrite(LEFT_MOTOR_SPEED, LOWEST_SPEED);
  analogWrite(RIGHT_MOTOR_SPEED, LOWEST_SPEED);
}
void backward()
{
  digitalWrite(LEFT_MOTOR_DIRECTION, GOING_BACKWARD);
  digitalWrite(RIGHT_MOTOR_DIRECTION, GOING_BACKWARD);
  analogWrite(LEFT_MOTOR_SPEED, LOWEST_SPEED);
  analogWrite(RIGHT_MOTOR_SPEED, LOWEST_SPEED);
}
void left()
{
  digitalWrite(LEFT_MOTOR_DIRECTION, GOING_BACKWARD);
  digitalWrite(RIGHT_MOTOR_DIRECTION, GOING_FORWARD);
  analogWrite(LEFT_MOTOR_SPEED, LOWEST_SPEED);
  analogWrite(RIGHT_MOTOR_SPEED, LOWEST_SPEED);
}
void right()
{
  digitalWrite(LEFT_MOTOR_DIRECTION, GOING_FORWARD);
  digitalWrite(RIGHT_MOTOR_DIRECTION, GOING_BACKWARD);
  analogWrite(LEFT_MOTOR_SPEED, LOWEST_SPEED);
  analogWrite(RIGHT_MOTOR_SPEED, LOWEST_SPEED);
}
void stop()
{
  analogWrite(LEFT_MOTOR_SPEED, STOP_MOTOR);
  analogWrite(RIGHT_MOTOR_SPEED, STOP_MOTOR);
}
